/// @cond EO_CXX_EO_IMPL

inline void elm::gengrid_item::show(Elm_Gengrid_Item_Scrollto_Type type_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_show(type_));
}

inline void elm::gengrid_item::bring_in(Elm_Gengrid_Item_Scrollto_Type type_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_bring_in(type_));
}

inline void elm::gengrid_item::update() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_update());
}

inline void elm::gengrid_item::fields_update(::efl::eina::string_view parts_, Elm_Gengrid_Item_Field_Type itf_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_fields_update(::efl::eolian::to_c(parts_), itf_));
}

inline void elm::gengrid_item::item_class_update(const Elm_Gengrid_Item_Class * itc_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_class_update(itc_));
}

inline ::elm::widget_item elm::gengrid_item::prev_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gengrid_item_prev_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::gengrid_item::next_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gengrid_item_next_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::gengrid_item::selected_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gengrid_item_selected_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::gengrid_item::selected_set(bool selected_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_selected_set(::efl::eolian::to_c(selected_)));
}

inline const Elm_Gengrid_Item_Class * elm::gengrid_item::item_class_get() const
{
   const Elm_Gengrid_Item_Class * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gengrid_item_class_get());
   return _tmp_ret;
}

inline int elm::gengrid_item::index_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gengrid_item_index_get());
   return _tmp_ret;
}

inline void elm::gengrid_item::pos_get(unsigned int* x_, unsigned int* y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_pos_get(x_, y_));
}

inline Elm_Object_Select_Mode elm::gengrid_item::select_mode_get() const
{
   Elm_Object_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gengrid_item_select_mode_get());
   return _tmp_ret;
}

inline void elm::gengrid_item::select_mode_set(Elm_Object_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_select_mode_set(mode_));
}

inline void eo_cxx::elm::gengrid_item::show(Elm_Gengrid_Item_Scrollto_Type type_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_show(type_));
}

inline void eo_cxx::elm::gengrid_item::bring_in(Elm_Gengrid_Item_Scrollto_Type type_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_bring_in(type_));
}

inline void eo_cxx::elm::gengrid_item::update() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_update());
}

inline void eo_cxx::elm::gengrid_item::fields_update(::efl::eina::string_view parts_, Elm_Gengrid_Item_Field_Type itf_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_fields_update(::efl::eolian::to_c(parts_), itf_));
}

inline void eo_cxx::elm::gengrid_item::item_class_update(const Elm_Gengrid_Item_Class * itc_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_class_update(itc_));
}

inline ::elm::widget_item eo_cxx::elm::gengrid_item::prev_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gengrid_item_prev_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::gengrid_item::next_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gengrid_item_next_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::gengrid_item::selected_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gengrid_item_selected_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::gengrid_item::selected_set(bool selected_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_selected_set(::efl::eolian::to_c(selected_)));
}

inline const Elm_Gengrid_Item_Class * eo_cxx::elm::gengrid_item::item_class_get() const
{
   const Elm_Gengrid_Item_Class * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gengrid_item_class_get());
   return _tmp_ret;
}

inline int eo_cxx::elm::gengrid_item::index_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gengrid_item_index_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::gengrid_item::pos_get(unsigned int* x_, unsigned int* y_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_pos_get(x_, y_));
}

inline Elm_Object_Select_Mode eo_cxx::elm::gengrid_item::select_mode_get() const
{
   Elm_Object_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_gengrid_item_select_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::gengrid_item::select_mode_set(Elm_Object_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_gengrid_item_select_mode_set(mode_));
}

inline ::eo_cxx::elm::gengrid_item::operator ::elm::gengrid_item() const
{
   return *static_cast<::elm::gengrid_item const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::gengrid_item::operator ::elm::gengrid_item&()
{
   return *static_cast<::elm::gengrid_item*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::gengrid_item::operator ::elm::gengrid_item const&() const
{
   return *static_cast<::elm::gengrid_item const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_gengrid_item_show_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Gengrid_Item_Scrollto_Type type_)
{
   try
      {
         static_cast<T*>(self->this_)->show(type_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_gengrid_item_bring_in_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Gengrid_Item_Scrollto_Type type_)
{
   try
      {
         static_cast<T*>(self->this_)->bring_in(type_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_gengrid_item_update_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->update();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_gengrid_item_fields_update_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * parts_, Elm_Gengrid_Item_Field_Type itf_)
{
   try
      {
         static_cast<T*>(self->this_)->fields_update(::efl::eolian::to_cxx<::efl::eina::string_view>(parts_, std::tuple<std::false_type>()), itf_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_gengrid_item_item_class_update_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Elm_Gengrid_Item_Class * itc_)
{
   try
      {
         static_cast<T*>(self->this_)->item_class_update(itc_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_gengrid_item_prev_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->prev_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_gengrid_item_next_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->next_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_gengrid_item_selected_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_gengrid_item_selected_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool selected_)
{
   try
      {
         static_cast<T*>(self->this_)->selected_set(::efl::eolian::to_cxx<bool>(selected_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
const Elm_Gengrid_Item_Class * elm_gengrid_item_item_class_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->item_class_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Elm_Gengrid_Item_Class * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
int elm_gengrid_item_index_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->index_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_gengrid_item_pos_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, unsigned int* x_, unsigned int* y_)
{
   try
      {
         static_cast<T*>(self->this_)->pos_get(x_, y_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Object_Select_Mode elm_gengrid_item_select_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->select_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Object_Select_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_gengrid_item_select_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Object_Select_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->select_mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::gengrid_item >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget_item >::template type<T>
   {
      virtual void show(Elm_Gengrid_Item_Scrollto_Type type_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gengrid_item_show(type_));
      }

      virtual void bring_in(Elm_Gengrid_Item_Scrollto_Type type_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gengrid_item_bring_in(type_));
      }

      virtual void update()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gengrid_item_update());
      }

      virtual void fields_update(::efl::eina::string_view parts_, Elm_Gengrid_Item_Field_Type itf_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gengrid_item_fields_update(::efl::eolian::to_c(parts_), itf_));
      }

      virtual void item_class_update(const Elm_Gengrid_Item_Class * itc_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gengrid_item_class_update(itc_));
      }

      virtual ::elm::widget_item prev_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_gengrid_item_prev_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item next_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_gengrid_item_next_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool selected_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_gengrid_item_selected_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void selected_set(bool selected_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gengrid_item_selected_set(::efl::eolian::to_c(selected_)));
      }

      virtual const Elm_Gengrid_Item_Class * item_class_get()
      {
         const Elm_Gengrid_Item_Class * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_gengrid_item_class_get());
            return _tmp_ret;
      }

      virtual int index_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_gengrid_item_index_get());
            return _tmp_ret;
      }

      virtual void pos_get(unsigned int* x_, unsigned int* y_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gengrid_item_pos_get(x_, y_));
      }

      virtual Elm_Object_Select_Mode select_mode_get()
      {
         Elm_Object_Select_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_gengrid_item_select_mode_get());
            return _tmp_ret;
      }

      virtual void select_mode_set(Elm_Object_Select_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_gengrid_item_select_mode_set(mode_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::gengrid_item >
{
   static constexpr int value = 
#if defined(GENGRID_ITEM_PROTECTED) && defined(GENGRID_ITEM_BETA)
      14
#elif defined(GENGRID_ITEM_PROTECTED)
      14
#elif defined(GENGRID_ITEM_BETA)
      14
#else
      14
#endif
      + operation_description_class_size<::elm::widget_item >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::gengrid_item>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_show_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_show);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_bring_in_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_bring_in);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_update_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_update);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_fields_update_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_fields_update);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_item_class_update_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_class_update);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_prev_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_prev_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_next_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_next_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_selected_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_selected_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_selected_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_selected_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_item_class_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_class_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_index_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_index_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_pos_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_pos_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_select_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_select_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_gengrid_item_select_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_gengrid_item_select_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget_item>(), &ops[operation_description_class_size< ::elm::gengrid_item >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::gengrid_item>)
{
   return (ELM_GENGRID_ITEM_CLASS);
}

} } }

/// @endcond

